# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20201101


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class MySqlFetchError(object):
    """
    Error from fetch operation of a MySQL server replication channel.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new MySqlFetchError object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param last_error_number:
            The value to assign to the last_error_number property of this MySqlFetchError.
        :type last_error_number: int

        :param last_error_message:
            The value to assign to the last_error_message property of this MySqlFetchError.
        :type last_error_message: str

        :param time_last_error:
            The value to assign to the time_last_error property of this MySqlFetchError.
        :type time_last_error: datetime

        """
        self.swagger_types = {
            'last_error_number': 'int',
            'last_error_message': 'str',
            'time_last_error': 'datetime'
        }
        self.attribute_map = {
            'last_error_number': 'lastErrorNumber',
            'last_error_message': 'lastErrorMessage',
            'time_last_error': 'timeLastError'
        }
        self._last_error_number = None
        self._last_error_message = None
        self._time_last_error = None

    @property
    def last_error_number(self):
        """
        **[Required]** Gets the last_error_number of this MySqlFetchError.
        The error number of the most recent error that caused the I/O thread to stop.


        :return: The last_error_number of this MySqlFetchError.
        :rtype: int
        """
        return self._last_error_number

    @last_error_number.setter
    def last_error_number(self, last_error_number):
        """
        Sets the last_error_number of this MySqlFetchError.
        The error number of the most recent error that caused the I/O thread to stop.


        :param last_error_number: The last_error_number of this MySqlFetchError.
        :type: int
        """
        self._last_error_number = last_error_number

    @property
    def last_error_message(self):
        """
        **[Required]** Gets the last_error_message of this MySqlFetchError.
        The error message of the most recent error that caused the I/O thread to stop.


        :return: The last_error_message of this MySqlFetchError.
        :rtype: str
        """
        return self._last_error_message

    @last_error_message.setter
    def last_error_message(self, last_error_message):
        """
        Sets the last_error_message of this MySqlFetchError.
        The error message of the most recent error that caused the I/O thread to stop.


        :param last_error_message: The last_error_message of this MySqlFetchError.
        :type: str
        """
        self._last_error_message = last_error_message

    @property
    def time_last_error(self):
        """
        **[Required]** Gets the time_last_error of this MySqlFetchError.
        The timestamp when the most recent I/O error occurred.


        :return: The time_last_error of this MySqlFetchError.
        :rtype: datetime
        """
        return self._time_last_error

    @time_last_error.setter
    def time_last_error(self, time_last_error):
        """
        Sets the time_last_error of this MySqlFetchError.
        The timestamp when the most recent I/O error occurred.


        :param time_last_error: The time_last_error of this MySqlFetchError.
        :type: datetime
        """
        self._time_last_error = time_last_error

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
